var moment = require('moment')
var ws = require('ws.js')
var Http = ws.Http
var Addr = ws.Addr
var parseString = require('xml2js').parseString;
var qs = require('qs')
var moment = require('moment')


function Client(options) {
  this.options   =  options || {}
  this.url = this.options.url
  this.loginMSM = this.options.loginMSM 
  this.passwordMSM = this.options.passwordMSM 
  this.codConvenioMSM = this.options.codConvenioMSM
  this.codEntidadAdqMSM = this.options.codEntidadAdqMSM
  this.dispositivoORIGMSM =  this.options.dispositivoORIGMSM
  this.codEntidadAutorizadoraMSM = this.options.codEntidadAutorizadoraMSM
  //actions
  this.consultaSaldoNombre = this.options.consultaSaldoNombre
  this.aplicaPago = this.options.aplicaPago
  this.reintentarPago = this.options.reintentarPago
  this.reversarPago = this.options.reversarPago
}


function buscaError(codError){
        let listaError =[ {"CODERR":71,
                          "MSN":"FACTURA NO EXISTE"},
                          {"CODERR":72,
                          "MSN":"FACTURA YA PAGADA"},
                          {"CODERR":98,
                          "MSN":"TRANSACCION EN CHEQUE NO AUTORIZADA"},
                          {"CODERR":99,
                          "MSN":"EL CLIENTE NO POSEE SALDO"},
                          {"CODERR":110,
                          "MSN":"ERROR GENERAL EN CONSULTAR SALDO"},
                          {"CODERR":111,
                          "MSN":"ACCESO DENEGADO. USUARIO Y PASSOWRD INCORRECTO. CONSULTARSALDO"},
                          {"CODERR":112,
                          "MSN":"PROBLEMAS AL INTETAR VALIDAR EL USUARIO. CONSULTAR SALDO"},
                          {"CODERR":113,
                          "MSN":"PROBLEMAS Al GUARDAR LOS DATOS D LA PETICION DE CONSULTA"},
                          {"CODERR":114,
                          "MSN":"OCURRIERON PROBLEMAS EN GUARDARRESPONSE DE COSULTAR SALDO"},
                          {"CODERR":120,
                          "MSN":"ERROR GENERAL EN APLICAR EL PAGO"},
                          {"CODERR":121,
                          "MSN":"ACCESO DENEGADO. USUARIO O PASSWORD INCORRECTO. APLICAR PAGO"},
                          {"CODERR":122,
                          "MSN":"PROBLEMAS Al INTENTAR VALIDAR EL USUARIO. APLICAR PAGO"},
                          {"CODERR":123,
                          "MSN":"EL ABONADO NO SE ENCUENTRA SCL. APLICAR PAGO"},
                          {"CODERR":124,
                          "MSN":"OCURRIERON INCONVENIENTES AL INTETAR VALIDAR EL USUARIO. APLICAR PAGO"},
                          {"CODERR":125,
                          "MSN":"OCURRIERON PROBLEMAS AL GUARDAR LOS DATOS DE LA PETICION. APLICAR PAGO"},
                          {"CODERR":126,
                          "MSN":"OCURRIERO INCONVEIENTES AL INTETAR APLICAR EL PAGO. APLICAR PAGO"},
                          {"CODERR":127,
                          "MSN":"OCURRIERON PROBLEMAS EN GUARDAR RESPONSE DE APLICAR PAGO"},
                          {"CODERR":130,
                          "MSN":"ERROR GENERAL EN REITENTAR PAGO"},
                          {"CODERR":131,
                          "MSN":"ACCESO DENEGADO USUARIO O PASSWORD INCORRECTO. REINTENTAR PAGO"},
                          {"CODERR":132,
                          "MSN":"PROBLEMAS AL INTENTAR VALIDAR EL USUARIO. REINTENTAR PAGO"},
                          {"CODERR":133,
                          "MSN":"EL ABONADO NO SE ENCUENTRA EN SCL. REINTERPAGO"},
                          {"CODERR":134,
                          "MSN":"OCURRIERON INCONVENIENTES AL INTENTENTAR VALIDAR LA RESPUESTA DEL INTENTO DE PAGO PREVIO"},
                          {"CODERR":135,
                          "MSN":"OCURRIERON PROBLEMAS AL ITENTAR VALIDAR LA PRETICION DEL INTENTO DE PAGO PREVIO. REINTENTAR PAGO"},
                          {"CODERR":136,
                          "MSN":"OCURRIERON PROBLEMAS AL INTENTAR VALIDAR LA RESPUESTA DEL INTENTO  DE PAGO PREVIO. REINTENTO DE PAGO"},
                          {"CODERR":137,
                          "MSN":"EL PAGO PREVIO O SE ENCUENTRA REGISTRADO. REITENTAR PAGO"},
                          {"CODERR":138,
                          "MSN":"OCURRIERON PROBLEMAS AL GUARDAR LOS DATOS DE LA PETICION  DE REINTENTO PAGO. REITENTAR PAGO"},
                          {"CODERR":139,
                          "MSN":"OCURRIERON INCONVEIENTES  AL ITENTAR APLICAR EL PAGO PARA EL CLIENTE. REITETAR PAGO."},
                          {"CODERR":140,
                          "MSN":"EL PAGO YA SE ECUENTRA APLICADO. REINTENTAR PAGO"},
                          {"CODERR":141,
                          "MSN":"OCURRIERON PROBLEMAS EN GUARDARRESPONSE DE REITENTAR PAGO"},
                          {"CODERR":142,
                          "MSN":"OCURRIERON PROBLEMAS AL CONSULTAR SALDO"},
                          {"CODERR":143,
                          "MSN":"EL NUMERO DE CONTROL ES OBLIGATORIO"},
                          {"CODERR":144,
                          "MSN":"LA FECHA ES OBLIGATORIA"},
                          {"CODERR":145,
                          "MSN":"EL NUMERO DE DOCUMENTO ES OBLIGATORIO"},
                          {"CODERR":146,
                          "MSN":"EL CODIGO DE OFICINA ES OBLIGATORIO"},
                          {"CODERR":147,
                          "MSN":"EL NUMERO DE TERMINAL ES OBLIGATORIO"},
                          {"CODERR":148,
                          "MSN":"EL DISPOSITIVO DE ORIGEN ES OBLIGATORIO"},
                          {"CODERR":149,
                          "MSN":"EL TIPO DE DISPOSITIVO NO SE ENCUENTRA EN LA BASE DE DATOS"},
                          {"CODERR":150,
                          "MSN":"EL CODIGO DE ENTIDAD ADQUIRIENTE ES OBLIGATORIO"},
                          {"CODERR":151,
                          "MSN":"EL CODIGO DE ENTIDAD ADQUIRIENTE NO SE ENCUENTRA EN LA BASE DE DATOS"},
                          {"CODERR":152,
                          "MSN":"EL CODIGO DE CONVENIO ES OBLIGATORIA"},
                          {"CODERR":153,
                          "MSN":"EL CODIGO DE CONVENIO NO SE ECUENTRA E LA BASE DE DATOS"},
                          {"CODERR":154,
                          "MSN":"LA COMBINACION DE CODIGO DE CONVENIO Y CODIGO DE ENTIDAD ADQUIRIENTE NO CONCUERDA CON EL QUE SE ENCUENTRA EN LA BASE DE DATOS"},
                          {"CODERR":155,
                          "MSN":"LA JORNADA DEBE SER OBLIGATORIA Y DEBE SER A O N"},
                          {"CODERR":156,
                          "MSN":"EL NUMERO DE AUTORIZACION ES OBLIGATORIO"},
                          {"CODERR":157,
                          "MSN":"EL NUMERO DE TERMINAL ES OBLIGATORIO"},
                          {"CODERR":158,
                          "MSN":"EL VALOR DE TRANSACCION ES OBLIGATORIO"},
                          {"CODERR":159,
                          "MSN":"EL VALOR DE LA TRASACCION NO ES IGUAL A LA SUMA DEL EFECTIVO Y DEL CHEQUE"},
                          {"CODERR":160,
                          "MSN":"LA COMBINACION DE CODIGO DE CONVENIO Y CODIGO DE ENTIDAD AUTORIZADORA NO CONCUERDA CON EL QUE SE ENCUENTRA EN LA BASE DE DATOS"},
                          {"CODERR":161,
                          "MSN":"EL CODIGO DE ENTIDAD AUTORIZADORA ES OBLIGATORIO"},
                          {"CODERR":162,
                          "MSN":"EL CODIGO DE ENTIDAD AUTORIZADORA NO SE ENCUENTRA E LA BASE DE DATOS"},
                          {"CODERR":163,
                          "MSN":"EL VALOR PAGOCHEQUE O EXISTE EN LA TABLA DE WSP_ETIDADES_AUTORIZADORAS"},
                          {"CODERR":164,
                          "MSN":"OCURRIERON PROBLEMAS AL CONSULTAR LA TABLA DE COFIGURACION"},
                          {"CODERR":165,
                          "MSN":"OCURRIERON PROBLEMAS AL INTENTAR CONSULTAR LA PETICION DE REINTENTO"},
                          {"CODERR":166,
                          "MSN":"OCURRIERON PROBLEMAS AL INTENTAR CONSULTAR LA RESPUESTA DE REINTENTO"},
                          {"CODERR":167,
                          "MSN":"OCURRIERON PROBLEMAS AL ACTUALIZAR LOS DATOS DE LA PETICION DE PAGO"},
                          {"CODERR":168,
                          "MSN":"OCURRIERON PROBLEMAS AL CONSULTAR LOS DATOS LOS DATOS DE LA PETICION DE PAGO"},
                          {"CODERR":169,
                          "MSN":"OCURRIERON PROBLEMAS AL ACTUALIZAR LOS DATOS DE LA PETICION DE REINTETO DE PAGO"},
                          {"CODERR":170,
                          "MSN":"OCURRIERON INCONVENIENTES AL INTETAR CONSULTAR LA RESPUESTA DE PAGO"},
                          {"CODERR":171,
                          "MSN":"OCURRIERON PROBLEMAS AL CONSULTAR LA TABLA DE ENTIDADES AUTORIZADORAS"},
                          {"CODERR":172,
                          "MSN":"CODIGO DE CLIENTE INVALIDO"},
                          {"CODERR":173,
                          "MSN":"ACCESO DENEGADO. USUARIO O PASSWORD INCORRECTO. DESAPLICARPAGO"},
                          {"CODERR":174,
                          "MSN":"OCURRIERON INCONVENIENTES AL INTENTAR VALIDAR EL USUARIO DESAPLICARPAGO"},
                          {"CODERR":175,
                          "MSN":"OCURRIERON PROBLEMAS AL GUARDAR LOS DATOS DE LA PETICION. DESAPLICARPAGO "},
                          {"CODERR":176,
                          "MSN":"OCURRIERON INCONVEIENTES AL INTENTAR DESAPLICAR EL PAGO. DESAPLICARPAGO"},
                          {"CODERR":177,
                          "MSN":"OCURRIERON PROBLEMAS EN GUARDARRESPONSE DE DESAPLICARPAGO."},
                          {"CODERR":178,
                          "MSN":"ERROR GENERAL EN DESAPLICAR PAGO."},
                          {"CODERR":179,
                          "MSN":"NO SE ENCUETRA REGISTRO DE NUMERO DE CONTROL/NUM DOCUMENTO E LA TABLA DE PAGOS O EL VALOR DE LA TRANSACCION O ES CORRECTO."},
                          {"CODERR":180,
                          "MSN":"YA SE APLICO UN PROCESO DE DESAPLICACION DE PAGOS PARA ESTE NUMERO  DE CONTROL/NUM DOCUMENTO"},
                          {"CODERR":181,
                          "MSN":"LA FECHA DE DESAPLICACION NO COINCIDE CON LA FECHA DE PAGO"},
                          {"CODERR":182,
                          "MSN":"OCURRIO UN ERROR EN EL PROCEDURE PR_DESAPLICACION"},
                          {"CODERR":183,
                           "MSN":"EL NUMERO DE CONTROL DE DESAPLICACION ES OBLIGATORIO"},
                          {"CODERR":184,
                           "MSN":"LA FECHA DE DESAPLICACION INGRESADA DEBE CORRESPONDER AL DIA DE HOY"},
                          {"CODERR":185,
                           "MSN":"EL USUARIO ENVIADO O TIENE PERMISOS PARA UTILIZAR ESTE METODO"},
                          {"CODERR":186,
                           "MSN":"EL CLIETE NO POSEE FINANCIAMIENTO DE EQUIPO"},
                          {"CODERR":188,
                           "MSN":"LOS CAMPOS DE MONTOS NO PUEDE CONTENER DECIMALES"},
                          {"CODERR":189,
                           "MSN":"NO SE PERMITEN DESAPLICAR PAGOS CON APLICACION DIFERENTE A SERVICIO"},
                         {"CODERR":190,
                          "MSN":"EL NUMERO DE CELULAR INDICADO NO SE ENCUENTRA REGISTRADO"},
                          {"CODERR":191,
                          "MSN":"NUMERO DE CELULAR INVALIDO"},
                          {"CODERR":192,
                          "MSN":"OCURRIERON ERROR AL CONSULTAR EL CLIENTE-SI PERSISTE CONSULTE A LA EMPRESA"},
                          {"CODERR":201,
                          "MSN":"DIGITO DE VERIFICACION INCORRECTO. VALIDE EL CODIGO"},
                          {"CODERR":202,
                          "MSN":"TRAMA DE 10DIGITOS SOLO ES VALIDA PARA COSULTA"},
                          {"CODERR":203,
                          "MSN":"TRAMA DE 9 DIGITOS SOLO ES VALIDA PARA CONSULTA"},
                          {"CODERR":204,
                          "MSN":"CANTIDAD DE DIGITOS EN EL DOCUMENTO ES INVALIDA"},
                          {"CODERR":205,
                          "MSN":"SOLO SE PERMITE DESAPLICAR SERVICIO MOVIL"},
                          {"CODERR":206,
                          "MSN":"OCURRIERON ERRORES AL CONSULTAR OPERACION FIJA - SI PERSISTE CONSULTE LA EMPRESA"},
                          {"CODERR":207,
                          "MSN":"REFERENCIA NO ADMITE POR ESTE MEDIO"},
                          {"CODERR":522,
                          "MSN":"LA FECHA DE APLICACION ES SUPERIOR A LA FECHA ACTUAL"},
                          {"CODERR":779,
                          "MSN":"NO EXISTE CODIGO DEL BANCO"},
                          {"CODERR":999,
                          "MSN":"ERROR GENERAL SI PERSISTE CONSULTE A LA EMPRESA"},
                          {"CODERR":1636,
                          "MSN":"MONTO DEL IMPORTE NO ES VALIDO"},
                          {"CODERR":1965,
                          "MSN":"CODIGO DEL CLIENTE NO EXISTE EN SERVICIO MOVIL"},
                          {"CODERR":5037,
                          "MSN":"FECHA DE PAGO PRESENTA FORMATO INVALIDO"},
                          {"CODERR":20064,
                          "MSN":"PAGO NO EXISTE"},  

                          


                                                ]
       let response = listaError.filter((error)=>{
            return error.CODERR == codError
                
            
        })    
        
        if (response.length>0) {
            return response
        
        }
        else {
            return [{"CODERR":666,
            "MSN":"ERROR DESCONOCIDO"}]
        }
}

Client.prototype._request = function(ctx, callback) {
    console.log('REQUEST CONSULTA MOVISTAR MOVIL')
    console.log('_______________________________')
    console.log('REQUEST:>>',ctx.request)
    console.log('-------------------------------')
  var handlers =  [new Http()]
  ws.send(handlers, ctx, function(result) {
    console.log('RESPONSE:>>',result.response)
    if(result.response){
    result = result.response.substr(297, result.response.length)
    result = result.substr(0,result.length-59)
    parseString(result , function (err, resultJSON) {
          if(err) return callback(err,null)
         
          if(resultJSON.ConsultarSaldoNombreResult.CodRespuesta[0]!='00') return callback(buscaError(resultJSON.ConsultarSaldoNombreResult.CodRespuesta[0]),null)
          callback(null,resultJSON.ConsultarSaldoNombreResult)
    });
    }

    else {callback('NO HAY RESPUESTA VALIDA DE MOVISTAR',null)}
  })
}

Client.prototype._requestPago = function(ctx, callback){
    console.log('REQUEST PAGO MOVISTAR MOVIL')
    console.log('REQUEST:>>',ctx.request)
    var handlers =  [new Http()]
    ws.send(handlers, ctx, function(result) {
        console.log('RESPONSE:>>',result.response)
        if(result.response){ 
      result = result.response.substr(288, result.response.length)
      result = result.substr(0,result.length-50)
      parseString(result , function (err, resultJSON) {
            if(err) return callback(err,null)
            if(resultJSON.AplicarPagoResult.CodRespuesta[0]!='00') return callback(buscaError(resultJSON.AplicarPagoResult.CodRespuesta[0]),null)
            callback(null,resultJSON.AplicarPagoResult)
      });
    }
     else {callback('NO HAY RESPUESTA VALIDA DE MOVISTAR',null)}

    })
  }
  
Client.prototype._requestReintentarPago = function(ctx, callback) {
    var handlers =  [new Http()]
    ws.send(handlers, ctx, function(result) {
      result = result.response.substr(291, result.response.length)
      result = result.substr(0,result.length-53)
      parseString(result , function (err, resultJSON) {
            if(err) return callback(err,null)
            if(resultJSON.ReintentarPagoResult.CodRespuesta[0]!='00') return callback(buscaError(resultJSON.ReintentarPagoResult.CodRespuesta[0]),null)
            callback(null,resultJSON.ReintentarPagoResult)
      });
  
    })
  }
  
Client.prototype._requestReversarPago =function (ctx, callback) {
    var handlers =  [new Http()]
    ws.send(handlers, ctx, function(result) {
        result = result.response.substr(291, result.response.length)
        result = result.substr(0,result.length-53)
        parseString(result , function (err, resultJSON) {
            if(err) return callback(err,null)
            if(resultJSON.ReintentarPagoResult.CodRespuesta[0]!='00') return callback(buscaError(resultJSON.ReintentarPagoResult.CodRespuesta[0]),null)
            callback(null,resultJSON.ReintentarPagoResult)
      });
  
    })
  } 
  

Client.prototype.consultarSaldoNombre = function(referenciaPago,codPunto,maquina,transId,user,password,callback){
    let numControl = moment(new Date()).format('DDMMx')     
    ctx =  { 
        request:' <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:co="http://co.com.movistar.ws.wspagosonline/">'+
                          
                          ' <soapenv:Header/>'+
                          ' <soapenv:Body>'+
                          ' <co:ConsultarSaldoNombre>'+
                          ' <co:login>'+user+'</co:login>'+
                          ' <co:password>'+password+'</co:password>'+
                          ' <co:requestConsulta>'+
                          ' <co:CodConvenio>'+this.codConvenioMSM+'</co:CodConvenio>'+
                          ' <co:CodEntAdquiriente>'+this.codEntidadAdqMSM +'</co:CodEntAdquiriente>'+
                          ' <co:NumControl>'+(transId?transId:numControl)+'</co:NumControl>'+
                          ' <co:Fecha>'+moment(new Date()).format('YYYY-MM-DDTHH:mm:ss')+'</co:Fecha>'+
                          ' <co:NumDocumento>'+referenciaPago+'</co:NumDocumento>'+
                          ' <co:CodOficina>'+codPunto+'</co:CodOficina>'+
                          ' <co:NumTerminal>'+maquina+'</co:NumTerminal>'+
                          ' <co:DispositivoOrigen>'+this.dispositivoORIGMSM+'</co:DispositivoOrigen>'+
                          ' </co:requestConsulta>'+
                          ' </co:ConsultarSaldoNombre>'+
                          ' </soapenv:Body>'+
                          ' </soapenv:Envelope>'
                            , url: this.url
                            , action: this.consultaSaldoNombre
                            , contentType: "text/xml"
                          }
                              
                               this._request(ctx, callback)
                             }



Client.prototype.setPago = function(referenciaPago,codPunto,maquina,transId,vlrTransaccion,vlrEfectivo,vlrCheque,jornada,numeroAutoriza,user,password,callback) {
    let numControl = moment(new Date()).format('DDMMx').slice(0,10)
  
    ctx =  { 
        request:' <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:co="http://co.com.movistar.ws.wspagosonline/">'+
                
                ' <soapenv:Header/>'+
                ' <soapenv:Body>'   +
                ' <co:AplicarPago>' +
                ' <co:login>'+user+'</co:login>' +
                ' <co:password>'+password+'</co:password>' +
                ' <co:requestPago>' +
                ' <co:CodConvenio>'+this.codConvenioMSM+'</co:CodConvenio>' +
                ' <co:CodEntAutorizadora>'+this.codEntidadAutorizadoraMSM+'</co:CodEntAutorizadora>' +
                ' <co:CodEntAdquiriente>'+this.codEntidadAdqMSM +'</co:CodEntAdquiriente>' +
                ' <co:NumControl>'+(transId?transId:numControl)+'</co:NumControl>'+
                ' <co:Fecha>'+moment(new Date()).format('YYYY-MM-DDTHH:mm:ss')+'</co:Fecha>' +
                ' <co:NumDocumento>'+referenciaPago+'</co:NumDocumento>' +
                ' <co:ValorTransaccion>'+vlrTransaccion+'</co:ValorTransaccion>' +
                ' <co:ValorEfectivo>'+vlrEfectivo+'</co:ValorEfectivo>' +
                ' <co:ValorCheque>'+vlrCheque+'</co:ValorCheque>' +
                ' <co:Jornada>'+jornada+'</co:Jornada>' +
                ' <co:NumAutorizacion>'+numeroAutoriza+'</co:NumAutorizacion>' +
                ' <co:CodOficina>'+codPunto+'</co:CodOficina>' +
                ' <co:NumTerminal>'+maquina+'</co:NumTerminal>' +
                ' <co:DispositivoOrigen>'+this.dispositivoORIGMSM+'</co:DispositivoOrigen>' +
                ' </co:requestPago>' +
                ' </co:AplicarPago>' +
                ' </soapenv:Body>' +
                ' </soapenv:Envelope>'
                , url: this.url
                , action: this.aplicaPago
                , contentType: "text/xml"
            }
                                              
                                               this._requestPago(ctx, callback)
                                             }
                          

                                             
Client.prototype.setReintentarPago = function(referenciaPago,codPunto,maquina,transId,vlrTransaccion,vlrEfectivo,vlrCheque,jornada,numeroAutoriza,callback) {
    let numControl = moment(new Date()).format('DDMMx')
    ctx =  { 
        request:'<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:co="http://co.com.movistar.ws.wspagosonline/">'+
                '<soapenv:Header/>'+
                '<soapenv:Body>'+
                '<co:ReintentarPago>'+
                '<co:login>'+this.loginMSM+'</co:login>'+
                '<co:password>'+this.passwordMSM+'</co:password>'+
                '<co:requestReintento>'+
                '<co:CodConvenio>'+this.codConvenioMSM+'</co:CodConvenio>'+
                '<co:CodEntAutorizadora>'+this.codEntidadAutorizadoraMSM+'</co:CodEntAutorizadora>'+
                '<co:CodEntAdquiriente>'+this.codEntidadAdqMSM +'</co:CodEntAdquiriente>'+
                '<co:NumControl>'+(transId?transId:numControl)+'</co:NumControl>'+
                '<co:Fecha>'+moment(new Date()).format('YYYY-MM-DDTHH:mm:ss')+'</co:Fecha>'+
                '<co:NumDocumento>'+referenciaPago+'</co:NumDocumento>'+
                '<co:ValorTransaccion>'+vlrTransaccion+'</co:ValorTransaccion>'+
                '<co:ValorEfectivo>'+vlrEfectivo+'</co:ValorEfectivo>'+
                '<co:ValorCheque>'+vlrCheque+'</co:ValorCheque>'+
                '<co:Jornada>'+jornada+'</co:Jornada>'+
                '<co:NumAutorizacion>'+numeroAutoriza+'</co:NumAutorizacion>'+
                '<co:CodOficina>'+codPunto+'</co:CodOficina>'+
                '<co:NumTerminal>'+maquina+'</co:NumTerminal>'+
                '<co:DispositivoOrigen>'+this.dispositivoORIGMSM+'</co:DispositivoOrigen>'+
                '</co:requestReintento>'+
                '</co:ReintentarPago>'+
                '</soapenv:Body>'+
                '</soapenv:Envelope>'
                , url: this.url
                , action: this.reintentarPago
                , contentType: "text/xml"
            }
                                                                                          
                this._requestReintentarPago(ctx, callback)
         }  

/*REVERSAR PAGO*/ 
Client.prototype.reversaPago = function(referenciaPago,codPunto,maquina,transId,vlrTransaccion,callback) {
    let numControl = moment(new Date()).format('DDMMx') 
    ctx =  { 
        request:' <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:co="http://co.com.movistar.ws.wspagosonline/">'+
        ' <soapenv:Header/>'+
        ' <soapenv:Body>'+
        ' <co:DesaplicarPago>'+
        ' <co:login>'+this.loginMSM+'</co:login>'+
        ' <co:password>'+this.passwordMSM+'</co:password>'+
        ' <co:requestDesaplicarPago>'+
        ' <co:CodConvenio>'+this.codConvenioMSM+'</co:CodConvenio>'+
        ' <co:CodEntAutorizadora>'+this.codEntidadAutorizadoraMSM+'</co:CodEntAutorizadora>'+
        ' <co:CodEntAdquiriente>'+this.codEntidadAdqMSM +'</co:CodEntAdquiriente>'+
        ' <co:Fecha>'+moment(new Date()).format('YYYY-MM-DDTHH:mm:ss')+'</co:Fecha>'+
        ' <co:NumControlPago>'+(transId?transId:numControl)+'</co:NumControlPago>'+
        ' <co:NumControlDesaplicar>'+(transId?transId:numControl)+'</co:NumControlDesaplicar>'+
        ' <co:NumDocumento>'+referenciaPago+'</co:NumDocumento>'+
        ' <co:CodOficina>'+codPunto+'</co:CodOficina>'+
        ' <co:DispositivoOrigen>'+this.dispositivoORIGMSM+'</co:DispositivoOrigen>'+
        ' <co:NumTerminal>'+maquina+'</co:NumTerminal>'+
        ' <co:ValorTransaccion>'+vlrTransaccion+'</co:ValorTransaccion>'+
        ' </co:requestDesaplicarPago>'+
        ' </co:DesaplicarPago>'+
        ' </soapenv:Body>'+
        ' </soapenv:Envelope>'
                , url: this.url
                , action: this.reversaPago 
                , contentType: "text/xml"
            }
                                                                                          
                this._requestReversarPago(ctx, callback)
         }        
module.exports = Client
